;---------------------------------------------;
;  program vypisuje ciselne hodnoty signalu,  ;
;      prichazejicich na A/D vstupy.          ;
;
;
;


	LIST	P = 16F877, R = DEC
	#include	<p16f877.inc>	; mozno psat take : "include p16f877.in"

	#include	displej.inc	; makro na obsuhu displeje
	#include	div16u.inc	; makro s algoritmem deleni
	#include	zobraz16.inc	; makro s algoritmem zobrazeni 16bitoveho cisla
	#include	znaky.inc		; definice zakladnich znaku dipleje
	#include	ad_prev.inc

	__CONFIG	B'11111100111010'

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

OFFRAM	EQU	H'20'		; ZACATEK VOLNE PAMETI "RAM"

#DEFINE	DB4	PORTE,2		; PINY PRO OVLADANI DISPLEJE
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

ZNAK_0	EQU	B'00110000'	; ADRESA ZNAKU "NULA" (PRO DISPLEJ)
ZNAK_SP	EQU	B'00100000'	; ADRESA ZNAKU "MEZERA"

;---------------------------------------------
;||||||||||| PROGRAMOVE PROMENNE |||||||||||||
;---------------------------------------------

	CBLOCK	OFFRAM
	DDATA:1			; POMOCNA PROM. OBSLUHY DISPLEJE
	TMH:1			; POMOCNA PROM. DVOJITEHO "DELAY" CYKLU
	TML:1

	AA:2			; OPERANDY A VYSLEDEK DELENI
	BB:2
	CC:2
	ARIT00:1			; POMOCNA PROM. DELENI

	AD_TEMP:1			; POMOCNA PROM. A/D PROCEDURY
	ADRESH_:1			; KUMULACNI A/D BUFFER
	ADRESL_:1			; - || -
	AD_COUNT:1		; POCITADLO A/D CYKLU
	ADRESH_A:1		; POMOCNA PROM. A/D HYSTEREZE
	ADRESL_A:1		; - || -
	ADRESH_B:1		; VYSTUPNI PROM. A/D HYSTEREZE
	ADRESL_B:1		; - || -
	ENDC

;----------------------------------------
;||||||||||| HLAVNI PROGRAM |||||||||||||
;----------------------------------------

	ORG	0
	NOP			; PREDPOKLADAM 3 REZERVOVANA
	NOP			; SLOVA PRO ZAVADEC
	NOP

START	MOVLW	B'10000001'	; NASTAVENI A/D PREVODNIKU
	MOVWF	ADCON0		
	MOVLW	B'10000100'
	BSF	STATUS,RP0
	MOVWF	ADCON1
	MOVLW	B'00000000'
	MOVWF	OPTION_REG
	BCF	STATUS,RP0

	CALL	INITDISP		; INICIALIZACE DISPLEJE
	
LOOP	MOVLW	0		; JDI NA NULTY ZNAK
	CALL	SETPOS

	MOVLW	0		; PROVED ZAKLADNI A/D PREVOD NA KANALU 0
	CALL	ADPREV1
	CALL	ZOBRAZ16		; ZOBRAZ VYSLEDEK A/D PREVODU NA DISPLEJI
	MOVLW	ZNAK_SP		; VLOZ MEZERU
	CALL	PUTZNAK
	MOVLW	ZNAK_SP		; VLOZ MEZERU
	CALL	PUTZNAK

	MOVLW	1		; PROVED NASOBNY A/D PREVOD NA KANALU 1
	CALL	ADPREV2
	CALL	ZOBRAZ16
	MOVLW	ZNAK_SP
	CALL	PUTZNAK
	MOVLW	ZNAK_SP
	CALL	PUTZNAK

	MOVLW	3		; PROVED STABILIZOVANY 12BITOVY A/D PREVOD NA KANALU 3
	CALL	ADPREV3
	CALL	ZOBRAZ16
	MOVLW	ZNAK_SP
	CALL	PUTZNAK

	GOTO	LOOP	

;----------------------------------------
;||| A/D PREVOD (STANDARDNI 10-BITOVY)|||
;----------------------------------------

ADPREV1	AD_PREV	AD_TEMP

ADPREV2	N_PREV	AD_TEMP,ADRESL_,ADRESH_,AD_COUNT,0

ADPREV3	H_PREV	AD_TEMP,ADRESL_,ADRESH_,AD_COUNT,ADRESL_A,ADRESL_B,ADRESH_A,ADRESH_B,2


; SOUBOR PODPROGRAMU NA ZAKLADNI OBSLUHU DISPLEJE	
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

; 16BITOVE DELENI BEZ ZNAMINKA
	DIV16U_M	AA,BB,CC,ARIT00

; ZOBRAZOVANI CISLA (POTENCIALNE 16BITOVE)
; - NASTAVENO TAK, ABY BYLO ZOBRAZENO JEN 8BITOVE CISLO V REGISTRU "W" (3 CISLICE)
; - BUDE SE POUZIVAT DELENI "DIV16U" A VYPIS ZNAKU NA DISPLEJ "PUTZNAK"
	ZOBR16_M	ADRESH,ADRESL,B'0001111',ZNAK_0,PUTZNAK,DIV16U,AA,BB,CC

	END
