DISPLEJ	MACRO	TMH,TML,DDATA,PO4,P4,PO5,P5,PO6,P6,PO7,P7,POE,PE,PORW,PRW,PORS,PRS
; sbirka zakladnich obsluznych rutin pro displej s radicem HD44780

; TMH,TML a DDATA jsou pracovni promenne
; (PO4,P4),(PO5,P5) a dalsi jsou definice portu a pinu pro nasledujici vodice:...
;     ...DB4,DB5,DB6,DB7,E,RW,RS

	LOCAL	DOUT4,DOUT8,WAIT_BF		; tato navesti jsou zvenka neviditelna
					; a nezpusobuji konflikt v nazvech

; Primitivni zpozdovaci rutina
; - ve W musi byt delka zpozdeni (1 znamena asi 770 cyklu)
DDELAY	MOVWF	TMH
	CLRF	TML
	DECFSZ	TML,F
	GOTO	$ - 1
	DECFSZ	TMH,F
	GOTO	$ - 3
	RETURN

;---------------------------------------------
;||||||||||  OBSLUHA DISPLEJE  |||||||||||||||
;---------------------------------------------

; Inicializace displeje
; - bez parametru
INITDISP	BSF	STATUS,RP0
	BCF	PO4,P4
	BCF	PO5,P5
	BCF	PO6,P6
	BCF	PO7,P7
	BCF	POE,PE
	BCF	PORW,PRW
	BCF	PORS,PRS
	BCF	STATUS,RP0
	BCF	PORS,PRS
	BCF	PORW,PRW
	MOVLW	D'255'
	CALL	DDELAY
	CALL	DDELAY
	CALL	DDELAY
	CALL	DDELAY
	MOVLW	B'00110000'
	CALL	DOUT4
	MOVLW	D'97'
	CALL	DDELAY
	MOVLW	B'00110000'
	CALL	DOUT4
	MOVLW	D'3'
	CALL	DDELAY
	MOVLW	B'00110000'
	CALL	DOUT4
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00100000'
	CALL	DOUT4
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00101000'
	CALL	DOUT8
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00001000'
	CALL	DOUT8
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00001100'
	CALL	DOUT8
	MOVLW	D'1'
	CALL	DDELAY
	MOVLW	B'00000001'
	CALL	DOUT8
	MOVLW	D'40'
	CALL	DDELAY
	MOVLW	B'00000110'
	CALL	DOUT8
	MOVLW	D'1'
	CALL	DDELAY
	RETURN

; 4 bity na vystup
; (interni rutina)
DOUT4	MOVWF	DDATA
	BSF	POE,PE
	BCF	PO4,P4
	BTFSC	DDATA,4
	BSF	PO4,P4
	BCF	PO5,P5
	BTFSC	DDATA,5
	BSF	PO5,P5
	BCF	PO6,P6
	BTFSC	DDATA,6
	BSF	PO6,P6
	BCF	PO7,P7
	BTFSC	DDATA,7
	BSF	PO7,P7
	BCF	POE,PE
	RETURN

; 8 bitu na vystup
; (interni rutina)
DOUT8	MOVWF	DDATA
	BSF	POE,PE
	BCF	PO4,P4
	BTFSC	DDATA,4
	BSF	PO4,P4
	BCF	PO5,P5
	BTFSC	DDATA,5
	BSF	PO5,P5
	BCF	PO6,P6
	BTFSC	DDATA,6
	BSF	PO6,P6
	BCF	PO7,P7
	BTFSC	DDATA,7
	BSF	PO7,P7
	BCF	POE,PE
	BCF	PO4,P4
	BTFSC	DDATA,0
	BSF	PO4,P4
	BCF	PO5,P5
	BTFSC	DDATA,1
	BSF	PO5,P5
	BSF	POE,PE
	BCF	PO6,P6
	BTFSC	DDATA,2
	BSF	PO6,P6
	BCF	PO7,P7
	BTFSC	DDATA,3
	BSF	PO7,P7
	BCF	POE,PE
	RETURN

; cekani na radic displeje (kontrola BF)
; (interni rutina)
WAIT_BF	BCF	PORS,PRS
	BSF	STATUS,RP0
	BSF	PO4,P4
	BSF	PO5,P5
	BSF	PO6,P6
	BSF	PO7,P7
	BCF	STATUS,RP0
	BSF	PORW,PRW
	BSF	POE,PE
	NOP
	NOP
	BCF	DDATA,7
	BTFSC	PO7,P7
	BSF	DDATA,7
	BCF	POE,PE
	NOP
	NOP
	BSF	POE,PE
	NOP
	NOP
	BCF	POE,PE
	NOP
	NOP
	BTFSC	DDATA,7
	GOTO	WAIT_BF
	BSF	STATUS,RP0
	BCF	PO4,P4
	BCF	PO5,P5
	BCF	PO6,P6
	BCF	PO7,P7
	BCF	STATUS,RP0
	BCF	PORW,PRW
	RETURN

; reset displeje (vymazani obsahu a nastaveni na zacatek)
; - bez parametru
DISPRESET	MOVLW	B'00000001'
	CALL	WAIT_BF		; overeni, respektive cekani na radic
	BCF	PORS,PRS
	CALL	DOUT8
	RETURN

; vypsani znaku
; - ve W musi byt ulozen kod znaku
PUTZNAK	CALL	WAIT_BF
	BSF	PORS,PRS
	CALL	DOUT8
	RETURN

; nastaveni polohy na displeji
; - ve W musi byt pozadovana poloha
SETPOS	IORLW	B'10000000'
	CALL	WAIT_BF
	BCF	PORS,PRS
	CALL	DOUT8
	RETURN

; nastaveni SG-adresy (uzivatelske znaky)
; - ve W musi byt pozadovana SG adresa
SETSGPOS	ANDLW	B'00111111'
	IORLW	B'01000000'
	CALL	WAIT_BF
	BCF	PORS,PRS
	CALL	DOUT8
	RETURN

	ENDM
